%{!?python_sitelib: %global python_sitelib %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib()")}

%define use_systemd 0%{?rhel} && 0%{?rhel} >= 7
%if %{use_systemd}
%define init_system systemd
%else
%define _udevrulesdir /lib/udev/rules.d
%define init_system sysvinit
%endif

Name:           cloud-init
Version:        18.4
Release:        2.0.9%{?dist}
Summary:        Cloud instance init scripts

Group:          System Environment/Base
License:        GPLv3
URL:            http://launchpad.net/cloud-init
Source0:        https://launchpad.net/cloud-init/trunk/%{version}/+download/%{name}-%{version}.tar.gz
%if %{use_systemd}
Source1:        cloud-init-tmpfiles.conf
%endif

Patch0001: 0001-Add-initial-redhat-setup.patch
Patch0002: 0001-disable-NM_CONTROLLED-no-in-generated-interface.patch
Patch0003: 0003-limit-permissions-on-def_log_file.patch
Patch0004: 0004-remove-tee-command-from-logging-configuration.patch
Patch0005: 0005-add-power-state-change-module-to-cloud_final_modules.patch
Patch0006: 0006-azure-ensure-that-networkmanager-hook-script-runs.patch
Patch0007: 0007-sysconfig-Don-t-write-BOOTPROTO-dhcp-for-ipv6-dhcp.patch
Patch0008: 0008-DataSourceAzure.py-use-hostnamectl-to-set-hostname.patch
Patch0009: 0009-sysconfig-Don-t-disable-IPV6_AUTOCONF.patch
Patch0010: 0010-ci-Adding-disk_setup-to-rhel-cloud.cfg.patch
Patch0011: 0011-ci-Adding-systemd-mount-options-to-wait-for-cloud-init.patch
Patch0012: 0012-net-wait-for-dhclient-to-daemonize.patch
Patch0014: 0014-Fix-swap-file-size.patch
Patch0015: 0015-enable-ec2_utils-to-stop-retrying-to-get-ec2-metadata.patch
Patch0017: 0017-total-seconds.patch
Patch0018: 0018-jinja2-implements_to_string.patch
Patch0019: 0019-cloud-init-collect-logs.patch
Patch0020: 0020-ol-cloud-config.patch
Patch0021: 0021-cc_ntp.py.patch
Patch0022: 0022-cc_spacewalk.py.patch
Patch0023: 0023-shlex_split.patch
Patch0024: 0024-sysconfig-keep-distro-generated-udev-rules-for-Oracle.patch
Patch0025: 0025-orabug30510275.patch
Patch0026: 0026-stages-clean-up-stale-network-configuration-on-new-i.patch
Patch0027: orabug30778399-001-hotplug-pull-hotplug-handler-WIP-changes.patch
Patch0028: orabug30778399-002-hotplug-additional-changes-to-hotplug-handler-WIP-pa.patch
Patch0029: orabug30778440-001-stages-allow-data-sources-to-override-network-config.patch
Patch0030: orabug30778440-002-net-cmdline-split-interfaces_by_mac-and-init-network.patch
Patch0031: orabug30778440-003-net-cmdline-support-reading-dracut-network-config-fr.patch
Patch0032: orabug30778440-004-OracleDataSource-should-configure-secondary-VNIC-usi.patch
Patch0033: orabug30778451-001-net-Oracle-Add-support-for-netfailover-detection.patch
Patch0034: orabug30778451-002-Oracle-remove-useless-and-toxic-_ensure_netfailover_.patch
Patch0035: orabug31086918-001-OracleDataSource-event-hotplug-excepti.patch
Patch0036: orabug31086918-002-sysconfig-set-per-platform-default-NM_.patch
Patch0037: orabug31086918-003-hotplug-remove-config-from-cache-durin.patch
Patch0038: orabug31086918-004-sysconfig-do-not-overwrite-HOSTNAME-co.patch
Patch0039: 0001-Update-OCI-Datasource-to-support-IMDSv2.patch
Patch0040: orabug31235189-001-hotplug-start-event-reporter-after-log.patch
Patch0041: orabug31235189-002-analyze-adjust-show-blame-for-hotplug-.patch
Patch0042: orabug31235189-003-stages-skip-update_event-during-first-.patch
Patch0043: orabug31235189-004-stages-allow-user-data-to-control-upda.patch
Patch0044: orabug31235189-005-hotplug-avoid-bogus-error-message-duri.patch

# Deal with noarch -> arch
# https://bugzilla.redhat.com/show_bug.cgi?id=1067089
Obsoletes:      cloud-init < 0.7.5-3

BuildRequires:  python-devel
BuildRequires:  python-requests
BuildRequires:  python-setuptools
BuildRequires:  python-six
BuildRequires:  python-yaml
%if %{use_systemd}
BuildRequires:  git
BuildRequires:  systemd
%else
BuildRequires:  initscripts
%endif
%if 0%{?rhel} && 0%{?rhel} == 6
BuildRequires:  python-argparse
%endif

Requires:       cloud-utils-growpart
Requires:       e2fsprogs
Requires:       gdisk
Requires:       iproute
Requires:       libselinux-python
Requires:       net-tools
Requires:       policycoreutils-python
Requires:       procps
Requires:       python >= 2.6.6-51
Requires:       python-configobj
Requires:       python-jinja2
Requires:       python-jsonpatch
Requires:       python-prettytable
Requires:       python-requests
Requires:       python-setuptools
Requires:       python-six
Requires:       PyYAML
Requires:       shadow-utils
Requires:       udev
Requires:       util-linux-ng

%ifarch %{?ix86} x86_64 ia64
Requires:       dmidecode
%endif

%if 0%{?rhel} && 0%{?rhel} == 6
Requires:  python-argparse
%endif

%if %{use_systemd}
Requires(post):   systemd-units
Requires(preun):  systemd-units
Requires(postun): systemd-units
%else
Requires:         initscripts >= 8.36
Requires(postun): initscripts
Requires(preun):  initscripts
Requires(post):   chkconfig
Requires(preun):  chkconfig
Requires(post):   coreutils
Requires(postun): coreutils
%endif

%description
Cloud-init is a set of init scripts for cloud instances.  Cloud instances
need special scripts to run during initialization to retrieve and install
ssh keys and to let the user run various scripts.


%prep
# on el7, autosetup -S git was failing with patches that
# # create new files.  rpm 4.11.3 and later has -S git_am, but
# # el7 only has 4.11.1.
%if %{use_systemd}
%autosetup -p1 -n %{name}-%{version} -S git
%else
%setup -q
%patch0001 -p1
%patch0002 -p1
%patch0003 -p1
%patch0004 -p1
%patch0005 -p1
%patch0006 -p1
%patch0007 -p1
%patch0008 -p1
%patch0009 -p1
%patch0010 -p1
%patch0011 -p1
%patch0012 -p1
%patch0014 -p1
%patch0015 -p1
%patch0017 -p1
%patch0018 -p1
%patch0019 -p1
%patch0020 -p1
%patch0021 -p1
%patch0022 -p1
%patch0023 -p1
%patch0024 -p1
%patch0025 -p1
%patch0026 -p1
%patch0027 -p1
%patch0028 -p1
%patch0029 -p1
%patch0030 -p1
%patch0031 -p1
%patch0032 -p1
%patch0033 -p1
%patch0034 -p1
%patch0035 -p1
%patch0036 -p1
%patch0037 -p1
%patch0038 -p1
%patch0039 -p1
%patch0040 -p1
%patch0041 -p1
%patch0042 -p1
%patch0043 -p1
%patch0044 -p1
%endif

%build
%{__python} setup.py build


%install
rm -rf $RPM_BUILD_ROOT
%{__python} setup.py install -O1 --skip-build --root $RPM_BUILD_ROOT --init-system=%{init_system}

mkdir -p $RPM_BUILD_ROOT/var/lib/cloud
# We supply our own config file since our software differs from Ubuntu's.
cp -p ol/cloud.cfg $RPM_BUILD_ROOT/%{_sysconfdir}/cloud/cloud.cfg

mkdir -p $RPM_BUILD_ROOT/%{_sysconfdir}/rsyslog.d
cp -p tools/21-cloudinit.conf $RPM_BUILD_ROOT/%{_sysconfdir}/rsyslog.d/21-cloudinit.conf
mkdir -p $RPM_BUILD_ROOT/%{_sysconfdir}/dhcp/dhclient-exit-hooks.d
cp -p tools/hook-dhclient $RPM_BUILD_ROOT/%{_sysconfdir}/dhcp/dhclient-exit-hooks.d/hook-dhclient

# Make installed NetworkManager hook name less generic
mv $RPM_BUILD_ROOT/etc/NetworkManager/dispatcher.d/hook-network-manager \
   $RPM_BUILD_ROOT/etc/NetworkManager/dispatcher.d/cloud-init-azure-hook

%if "%{init_system}" == "systemd"
# /run/cloud-init needs a tmpfiles.d entry
mkdir -p $RPM_BUILD_ROOT/run/cloud-init
mkdir -p $RPM_BUILD_ROOT/%{_tmpfilesdir}
cp -p rhel/cloud-init-tmpfiles.conf $RPM_BUILD_ROOT/%{_tmpfilesdir}/%{name}.conf

# Install our own systemd units (rhbz#1440831)
mkdir -p $RPM_BUILD_ROOT%{_unitdir}
cp rhel/systemd/* $RPM_BUILD_ROOT%{_unitdir}/
%else
# Cloud-init relies on /run/cloud-init being temporary.
# Create a symlink to /var/run/cloud-init to mock it.
mkdir -p $RPM_BUILD_ROOT/var/run/cloud-init
# Scriptlets don't differentiate between downgrade and upgrade. We may identify RPM version
# with this symlink requirement using a specific checker file.
mkdir -p $RPM_BUILD_ROOT/var/lib/cloud-init
touch $RPM_BUILD_ROOT/var/lib/cloud-init/.checker_rundir_linking
touch $RPM_BUILD_ROOT/var/lib/cloud-init/.checker_hotplugd_service
chmod 0755 $RPM_BUILD_ROOT%{_libexecdir}/%{name}/hook-hotplug
%endif

# Remove CloudSigma and SmartOS data source
rm -f $RPM_BUILD_ROOT/usr/lib/python2.6/site-packages/cloudinit/sources/{DataSourceCloudSigma.py*,DataSourceSmartOS.py*}

# Remove rh_subscription files
rm -f $RPM_BUILD_ROOT/usr/lib/python2.6/site-packages/cloudinit/config/cc_rh_subscription.py*
rm -f $RPM_BUILD_ROOT/usr/share/doc/cloud-init/examples/cloud-config-rh_subscription.txt

%clean
rm -rf $RPM_BUILD_ROOT


%post
%if "%{init_system}" == "systemd"
if [ $1 -eq 1 ] ; then
    # Initial installation
    # Enabled by default per "runs once then goes away" exception
    /bin/systemctl enable cloud-config.service     >/dev/null 2>&1 || :
    /bin/systemctl enable cloud-final.service      >/dev/null 2>&1 || :
    /bin/systemctl enable cloud-init.service       >/dev/null 2>&1 || :
    /bin/systemctl enable cloud-init-local.service >/dev/null 2>&1 || :
    /bin/systemctl enable cloud-init-hotplugd.socket  >/dev/null 2>&1 || :
    /bin/systemctl enable cloud-init-hotplugd.service >/dev/null 2>&1 || :
elif [ $1 -eq 2 ]; then
    # Upgrade. If the upgrade is from a version older than 0.7.9-8,
    # there will be stale systemd config
    /bin/systemctl is-enabled cloud-config.service >/dev/null 2>&1 &&
      /bin/systemctl reenable cloud-config.service >/dev/null 2>&1 || :

    /bin/systemctl is-enabled cloud-final.service >/dev/null 2>&1 &&
      /bin/systemctl reenable cloud-final.service >/dev/null 2>&1 || :

    /bin/systemctl is-enabled cloud-init.service >/dev/null 2>&1 &&
      /bin/systemctl reenable cloud-init.service >/dev/null 2>&1 || :

    /bin/systemctl is-enabled cloud-init-local.service >/dev/null 2>&1 &&
      /bin/systemctl reenable cloud-init-local.service >/dev/null 2>&1 || :

    /bin/systemctl is-enabled cloud-init-hotplugd.socket >/dev/null 2>&1 &&
      /bin/systemctl reenable cloud-init-hotplugd.socket >/dev/null 2>&1 || :

    /bin/systemctl is-enabled cloud-init-hotplugd.service >/dev/null 2>&1 &&
      /bin/systemctl reenable cloud-init-hotplugd.service >/dev/null 2>&1 || :
fi
%else

# Cloud-init relies on /run/cloud-init being temporary.
# Create a symlink to /var/run/cloud-init to mock it.
rund=0
if [ -e /run ] ; then
    if [ "$(/usr/bin/stat -f -c %T /run)" = "tmpfs" ] ; then
        rund=1
    elif [ "$(/bin/readlink -f -e /run)" = "/var/run" ] ; then
        rund=2
    fi
else
    /bin/mkdir /run
fi

if [ $1 -eq 1 ] ; then
    # Initial installation
    if [ $rund -eq 0 ] ; then
        /bin/rm -r -f /run/cloud-init
        /bin/ln -s -f ../var/run/cloud-init /run/cloud-init
    fi
    /sbin/chkconfig --add %{_initrddir}/cloud-init-local
    /sbin/chkconfig --add %{_initrddir}/cloud-init
    /sbin/chkconfig --add %{_initrddir}/cloud-config
    /sbin/chkconfig --add %{_initrddir}/cloud-final
    /sbin/chkconfig --add %{_initrddir}/cloud-init-hotplugd
    /sbin/chkconfig cloud-init-local on 
    /sbin/chkconfig cloud-init on 
    /sbin/chkconfig cloud-config on 
    /sbin/chkconfig cloud-final on
    /sbin/chkconfig cloud-init-hotplugd on
elif [ $1 -eq 2 ] ; then
    # Upgrade
    if [ $rund -eq 0 ] ; then
        if [ ! -e /run/cloud-init ] ; then
            /bin/ln -s -f ../var/run/cloud-init /run/cloud-init
        # The /run/cloud-init directory might exist pre-upgrade for various reasons:
        #   . It's a symlink that was created by this dir-linking post script,
        #     and is currently pointing to /var/run/cloud-init. Nothing needs
        #     to be done for it while upgrading.
        #   . The directory was created by an older version of cloud-init
        #     which doesn't require /run/cloud-init being temproray.
        #     Migrate all data under such hard-boiled directory, and get
        #     it relinked to the real backing directory, /var/run/cloud-init.
        #   . For the rest of other cases, just create a symlink pointing
        #     to the real backing diretory.
        elif [ "$(/bin/readlink -f /run/cloud-init)" != "/var/run/cloud-init" ] ; then
            if [ -d /run/cloud-init ] ; then
                /bin/cp -r -p /run/cloud-init/. /var/run/cloud-init
                # Fix broken symlinks that are referencing relative directory path
                for symlink in /var/run/cloud-init/* ; do
                    [ -L $symlink ] || continue
                    [ -e $symlink ] && continue
                    oldlink="/run/cloud-init/$(/bin/basename $symlink)"
                    [ -e $oldlink ] || continue
                    /bin/ln -s -f $(/bin/readlink -f $oldlink) $symlink
                done
            fi
            /bin/rm -r -f /run/cloud-init
            /bin/ln -s -f ../var/run/cloud-init /run/cloud-init
        fi
    fi

    # Don't re-enable cloud-init-hotplugd if it's already present
    # but disabled. Only enable it at the first time of upgrade.
    if ! /sbin/chkconfig --list cloud-init-hotplugd >/dev/null 2>&1 ; then
        /sbin/chkconfig --add %{_initrddir}/cloud-init-hotplugd
        /sbin/chkconfig cloud-init-hotplugd on
    fi

    # If the upgrade is from a version older than 0.7.9-8,
    # there will be rc.d config with stale priority order
    /sbin/chkconfig cloud-init-local resetpriorities
    /sbin/chkconfig cloud-init resetpriorities
    /sbin/chkconfig cloud-config resetpriorities
    /sbin/chkconfig cloud-final resetpriorities
fi
%endif

%preun
%if "%{init_system}" == "systemd"
if [ $1 -eq 0 ] ; then
    # Package removal, not upgrade
    /bin/systemctl --no-reload disable cloud-config.service >/dev/null 2>&1 || :
    /bin/systemctl --no-reload disable cloud-final.service  >/dev/null 2>&1 || :
    /bin/systemctl --no-reload disable cloud-init.service   >/dev/null 2>&1 || :
    /bin/systemctl --no-reload disable cloud-init-local.service >/dev/null 2>&1 || :
    /bin/systemctl --no-reload disable cloud-init-hotplugd.service >/dev/null 2>&1 || :
    /bin/systemctl --no-reload disable cloud-init-hotplugd.socket  >/dev/null 2>&1 || :
    # One-shot services -> no need to stop
fi
%else
if [ $1 -eq 0 ] ; then
    # Package removal
    /sbin/service cloud-init stop >/dev/null 2>&1 || :
    /sbin/chkconfig --del cloud-init || :
    /sbin/service cloud-init-local stop >/dev/null 2>&1 || :
    /sbin/chkconfig --del cloud-init-local || :
    /sbin/service cloud-config stop >/dev/null 2>&1 || :
    /sbin/chkconfig --del cloud-config || :
    /sbin/service cloud-final stop >/dev/null 2>&1 || :
    /sbin/chkconfig --del cloud-final || :
    /sbin/service cloud-init-hotplugd stop >/dev/null 2>&1 || :
    /sbin/chkconfig --del cloud-init-hotplugd || :
    if [ -L /run/cloud-init ] ; then
        /bin/rm -f /run/cloud-init
        # /run not deleted as it might be created by external software
    fi
fi
%endif

%postun
%if "%{init_system}" == "systemd"
    /bin/systemctl daemon-reload >/dev/null 2>&1 || :
    # One-shot services -> no need to restart
%else
if [ $1 -eq 1 ] ; then
    # Package downgrade (if feature checker doesn't exist)

    # cloud-init-hotplugd daemon might still be running, but
    # the regarding service had been removed from chkconfig
    # management. Try to stop the daemon manually and clean
    # up dangling files that were used to track the service.
    pidfile=/var/run/cloud-init-hotplugd.pid
    if [ -s $pidfile ] &&
       [ ! -e /var/lib/cloud-init/.checker_hotplugd_service ] ; then
        force=1
        pipe=/run/cloud-init/hook-hotplug-cmd
        # Be polite first
        if [ -p $pipe ] ; then
            echo quit > $pipe
            for i in {1..5} ; do
                /bin/sleep 1
                # Daemon would clean up the pipie
                # upon graceful termination.
                if [ ! -p $pipe ] ; then
                    force=0
                    break
                fi
            done
        fi
        # Something bad happened, sorry for being tough...
        # It would be okay if the daemon process became
        # zombie already. It should be fine for new daemon
        # to come up and running again if the pipe is no
        # longer there. So be sure to clean up the pipe.
        if [ $force -eq 1 ] ; then
            kill -KILL $(< $pidfile) >/dev/null 2>&1 || :
            /bin/rm -f $pipe
        fi
        /bin/rm -f $pidfile
        /bin/rm -f /var/lock/subsys/cloud-init-hotplugd
    fi

    # Reset serivce priority back to that of the older version
    if [ -L /run/cloud-init ] &&
       [ ! -e /var/lib/cloud-init/.checker_rundir_linking ] ; then
        /sbin/chkconfig cloud-init-local resetpriorities
        /sbin/chkconfig cloud-init resetpriorities
        /sbin/chkconfig cloud-config resetpriorities
        /sbin/chkconfig cloud-final resetpriorities
        /bin/rm -f /run/cloud-init
    fi
fi
%endif

%files
%doc ChangeLog ol/README.ol LICENSE
%config(noreplace) %{_sysconfdir}/cloud/cloud.cfg
%dir               %{_sysconfdir}/cloud/cloud.cfg.d
%config(noreplace) %{_sysconfdir}/cloud/cloud.cfg.d/*.cfg
%doc               %{_sysconfdir}/cloud/cloud.cfg.d/README
%dir               %{_sysconfdir}/cloud/templates
%config(noreplace) %{_sysconfdir}/cloud/templates/*
%{python_sitelib}/*
%{_libexecdir}/%{name}
%{_bindir}/cloud-init*
%doc %{_datadir}/doc/%{name}
%dir /var/lib/cloud
/etc/NetworkManager/dispatcher.d/cloud-init-azure-hook
%dir %{_sysconfdir}/dhcp/dhclient-exit-hooks.d
%{_sysconfdir}/dhcp/dhclient-exit-hooks.d/hook-dhclient
%{_udevrulesdir}/10-cloud-init-hook-hotplug.rules
%{_udevrulesdir}/66-azure-ephemeral.rules
%if "%{init_system}" == "systemd"
%dir /run/cloud-init
%{_unitdir}/cloud-config.service
%{_unitdir}/cloud-config.target
%{_unitdir}/cloud-final.service
%{_unitdir}/cloud-init-local.service
%{_unitdir}/cloud-init.service
%{_tmpfilesdir}/%{name}.conf
%else
%dir /var/lib/cloud-init
/var/lib/cloud-init/.checker_rundir_linking
/var/lib/cloud-init/.checker_hotplugd_service
%dir /var/run/cloud-init
%attr(0755, root, root) %{_initddir}/cloud-config
%attr(0755, root, root) %{_initddir}/cloud-final
%attr(0755, root, root) %{_initddir}/cloud-init-local
%attr(0755, root, root) %{_initddir}/cloud-init
%attr(0755, root, root) %{_initddir}/cloud-init-hotplugd
%attr(0755, root, root) %{_sbindir}/cloud-init-hotplugd
%endif
%dir %{_sysconfdir}/rsyslog.d
%config(noreplace) %{_sysconfdir}/rsyslog.d/21-cloudinit.conf

%changelog
* Mon Jun 22 2020 Si-Wei Liu <si-wei.liu@oracle.com> - 18.4-2.0.9
- start event reporter after logging is configured [Orabug: 31235189]
- adjust analyze show/blame output for hotplug records [Orabug: 31235189]
- stages should skip update_event for first boot [Orabug: 31235189]
- stages can allow user-data to control update-events [Orabug: 31235189]
- avoid bogus error message during hotplugd shutdown [Orabug: 31235189]

* Tue Apr 14 2020 Edward Leung <edward.leung@oracle.com> - 18.4-2.0.8
- Update OCI Datasource to support IMDSv2

* Mon Mar 30 2020 Si-Wei Liu <si-wei.liu@oracle.com> - 18.4-2.0.7
- Avoid hotplug handling when configure_secondary_nics is disabled [Orabug: 31086918]
- Set per-platform default NM_CONTROLLED=no for OCI [Orabug: 31086918]
- Remove secondary vnic config from cache during hot unplug [Orabug: 31086918]
- Do not overwrite HOSTNAME config in /etc/sysconfig/network [Orabug: 31086918]

* Tue Feb 11 2020 Si-Wei Liu <si-wei.liu@oracle.com> - 18.4-2.0.6
- Add hotplug event handling support [Orabug: 30778399]
- Oracle data source should configure secondary VNICs [Orabug: 30778440]
- Add support for net_failover 3-netdev model [Orabug: 30778451]

* Mon Nov 25 2019 Vijay Balakrishna <vijay.balakrishna@oracle.com> - 18.4-2.0.5
- Fix OL distro specific issues and dependency compatibility [Orabug: 30435672]
- Issus related to cloud-init upgrade from 0.7.4 to 18.4 [30510275]

* Sun Aug 11 2019 Livy Ge <livy.ge@oracle.com> - 18.4-2.0.2
- Changes to ignore all enslaved interfaces [Orabug: 30092148]
- add modified version of enable-ec2_utils-to-stop-retrying-to-get-ec2-metadata.patch for 18.2:
  1. Enable ec2_utils.py having a way to stop retrying to get ec2 metadata
  2. Apply stop retrying to get ec2 metadata to helper/openstack.py MetadataReader

* Mon Jul 22 2019 Livy Ge <livy.ge@oracle.com> - 18.4-2.0.1
- Fix swap file size allocation logic to allocate maxsize [Orabug: 29952349]
- Make Oracle datasource detect dracut based config files [Orabug: 29956753]
- Backport: net: Wait for dhclient to daemonize before reading lease file [Orabug: 29934932]

* Wed Jun 19 2019 Livy Ge <livy.ge@oracle.com> - 18.4-2
- remove pyserial requriement and CloudSigma/SmartOS data source

* Wed Dec  5 2018 Livy Ge <livy.ge@oracle.com> - 18.4-1
- rebase to upstream 18.4

* Thu Sep 27 2018 Miroslav Rezanina <mrezanin@redhat.com> - 18.2-1.el7_6.1
- ci-Adding-systemd-mount-options-to-wait-for-cloud-init.patch [bz#1633282]
- ci-Azure-Ignore-NTFS-mount-errors-when-checking-ephemer.patch [bz#1633282]
- ci-azure-Add-reported-ready-marker-file.patch [bz#1633282]
- ci-Adding-disk_setup-to-rhel-cloud.cfg.patch [bz#1633282]
- Resolves: bz#1633282
  ([Azure] cloud-init fails to mount /dev/sdb1 after stop(deallocate)&&start VM)

* Thu Jun 21 2018 Miroslav Rezanina <mrezanin@redhat.com>
- Rebase to 18.2
  Resolves: rhbz#1525267

* Tue Feb 13 2018 Ryan McCabe <rmccabe@redhat.com> 0.7.9-24
- Set DHCP_HOSTNAME on Azure to allow for the hostname to be
  published correctly when bouncing the network.
  Resolves: rhbz#1434109

* Mon Jan 15 2018 Ryan McCabe <rmccabe@redhat.com> 0.7.9-23
- Fix a bug tha caused cloud-init to fail as a result of trying
  to rename bonds.
  Resolves: rhbz#1512247

* Mon Jan 15 2018 Ryan McCabe <rmccabe@redhat.com> 0.7.9-22
- Apply patch from -21
  Resolves: rhbz#1489270

* Mon Jan 15 2018 Ryan McCabe <rmccabe@redhat.com> 0.7.9-21
- sysconfig: Fix a potential traceback introduced in the
  0.7.9-17 build
  Resolves: rhbz#1489270

* Sun Dec 17 2017 Ryan McCabe <rmccabe@redhat.com> 0.7.9-20
- sysconfig: Correct rendering for dhcp on ipv6
  Resolves: rhbz#1519271

* Thu Nov 30 2017 Ryan McCabe <rmccabe@redhat.com> 0.7.9-19
- sysconfig: Fix rendering of default gateway for ipv6
  Resolves: rhbz#1492726

* Fri Nov 24 2017 Ryan McCabe <rmccabe@redhat.com> 0.7.9-18
- Start the cloud-init init local service after the dbus socket is created
  so that the hostnamectl command works.
  Resolves: rhbz#1450521

* Tue Nov 21 2017 Ryan McCabe <rmccabe@redhat.com> 0.7.9-17
- Correctly render DNS and DOMAIN for sysconfig
  Resolves: rhbz#1489270

* Mon Nov 20 2017 Ryan McCabe <rmccabe@redhat.com> 0.7.9-16
- Disable NetworkManager management of resolv.conf if nameservers
  are specified by configuration.
  Resolves: rhbz#1454491

* Mon Nov 13 2017 Ryan McCabe <rmccabe@redhat.com> 0.7.9-15
- Fix a null reference error in the rh_subscription module
  Resolves: rhbz#1498974

* Mon Nov 13 2017 Ryan McCabe <rmccabe@redhat.com> 0-7.9-14
- Include gateway if it's included in subnet configration
  Resolves: rhbz#1492726

* Sun Nov 12 2017 Ryan McCabe <rmccabe@redhat.com> 0-7.9-13
- Do proper cleanup of systemd units when upgrading from versions
  0.7.9-3 through 0.7.9-8.
  Resolves: rhbz#1465730

* Thu Nov 09 2017 Ryan McCabe <rmccabe@redhat.com> 0.7.9-12
- Prevent Azure NM and dhclient hooks from running when cloud-init is
  disabled (rhbz#1474226)

* Tue Oct 31 2017 Ryan McCabe <rmccabe@redhat.com> 0.7.9-11
- Fix rendering of multiple static IPs per interface file
  Resolves: rhbz#bz1497954

* Tue Sep 26 2017 Ryan McCabe <rmccabe@redhat.com> 0.7.9-10
- AliCloud: Add support for the Alibaba Cloud datasource (rhbz#1482547)

* Thu Jun 22 2017 Lars Kellogg-Stedman <lars@redhat.com> 0.7.9-9
- RHEL/CentOS: Fix default routes for IPv4/IPv6 configuration. (rhbz#1438082)
- azure: ensure that networkmanager hook script runs (rhbz#1440831 rhbz#1460206)
- Fix ipv6 subnet detection (rhbz#1438082)

* Tue May 23 2017 Lars Kellogg-Stedman <lars@redhat.com> 0.7.9-8
- Update patches

* Mon May 22 2017 Lars Kellogg-Stedman <lars@redhat.com> 0.7.9-7
- Add missing sysconfig unit test data (rhbz#1438082)
- Fix dual stack IPv4/IPv6 configuration for RHEL (rhbz#1438082)
- sysconfig: Raise ValueError when multiple default gateways are present. (rhbz#1438082)
- Bounce network interface for Azure when using the built-in path. (rhbz#1434109)
- Do not write NM_CONTROLLED=no in generated interface config files (rhbz#1385172)

* Wed May 10 2017 Lars Kellogg-Stedman <lars@redhat.com> 0.7.9-6
- add power-state-change module to cloud_final_modules (rhbz#1252477)
- remove 'tee' command from logging configuration (rhbz#1424612)
- limit permissions on def_log_file (rhbz#1424612)
- Bounce network interface for Azure when using the built-in path. (rhbz#1434109)
- OpenStack: add 'dvs' to the list of physical link types. (rhbz#1442783)

* Wed May 10 2017 Lars Kellogg-Stedman <lars@redhat.com> 0.7.9-5
- systemd: replace generator with unit conditionals (rhbz#1440831)

* Thu Apr 13 2017 Charalampos Stratakis <cstratak@redhat.com> 0.7.9-4
- Import to RHEL 7
Resolves: rhbz#1427280

* Tue Mar 07 2017 Lars Kellogg-Stedman <lars@redhat.com> 0.7.9-3
- fixes for network config generation
- avoid dependency cycle at boot (rhbz#1420946)

* Tue Jan 17 2017 Lars Kellogg-Stedman <lars@redhat.com> 0.7.9-2
- use timeout from datasource config in openstack get_data (rhbz#1408589)

* Thu Dec 01 2016 Lars Kellogg-Stedman <lars@redhat.com> - 0.7.9-1
- Rebased on upstream 0.7.9.
- Remove dependency on run-parts

* Wed Jan 06 2016 Lars Kellogg-Stedman <lars@redhat.com> - 0.7.6-8
- make rh_subscription plugin do nothing in the absence of a valid
  configuration [RH:1295953]
- move rh_subscription module to cloud_config stage

* Wed Jan 06 2016 Lars Kellogg-Stedman <lars@redhat.com> - 0.7.6-7
- correct permissions on /etc/ssh/sshd_config [RH:1296191]

* Thu Sep 03 2015 Lars Kellogg-Stedman <lars@redhat.com> - 0.7.6-6
- rebuild for ppc64le

* Tue Jul 07 2015 Lars Kellogg-Stedman <lars@redhat.com> - 0.7.6-5
- bump revision for new build

* Tue Jul 07 2015 Lars Kellogg-Stedman <lars@redhat.com> - 0.7.6-4
- ensure rh_subscription plugin is enabled by default

* Wed Apr 29 2015 Lars Kellogg-Stedman <lars@redhat.com> - 0.7.6-3
- added dependency on python-jinja2 [RH:1215913]
- added rhn_subscription plugin [RH:1227393]
- require pyserial to support smartos data source [RH:1226187]

* Fri Jan 16 2015 Lars Kellogg-Stedman <lars@redhat.com> - 0.7.6-2
- Rebased RHEL version to Fedora rawhide
- Backported fix for https://bugs.launchpad.net/cloud-init/+bug/1246485
- Backported fix for https://bugs.launchpad.net/cloud-init/+bug/1411829

* Fri Nov 14 2014 Colin Walters <walters@redhat.com> - 0.7.6-1
- New upstream version [RH:974327]
- Drop python-cheetah dependency (same as above bug)
